﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using Winshuttle.Finx.WF.Interfaces;
using Winshuttle.Finx.WF.Models;

namespace ClassLibrary1
{
    public class ValidateFormTest: IFormValidator
    {
        public FormValidatorResult ValidateForm(string theXml)
        {
            XmlDocument objFormXml = new XmlDocument();
            objFormXml.LoadXml(theXml);
            bool allOk = false;
            XmlNamespaceManager formNamespace = LoadXmlNamespace(objFormXml);
            XmlNode objTokenNode =  objFormXml.SelectSingleNode("//my:mytoken", formNamespace);
            if(objTokenNode != null)
            {
                string innerText = objTokenNode.InnerText.Trim();
                if(innerText == "$abcd1234")
                {
                    allOk = true;
                }
            }

            if (!allOk)
            {
                return new FormValidatorResult { ErrorFieldXPaths = new string[] { "/Details/Surname/my:field3" }, Message = "Something terrible happened.", Status = FormValidatorStatus.Error };
            }
            else
            {
                return new FormValidatorResult { Status = FormValidatorStatus.OK };
            }
        }

        private XmlNamespaceManager LoadXmlNamespace(XmlDocument xmlDoc)
        {
            XmlNamespaceManager manager = null;
            if (xmlDoc?.DocumentElement != null)
            {
                manager = new XmlNamespaceManager(xmlDoc.NameTable);
                foreach (XmlAttribute attribute in xmlDoc.DocumentElement.Attributes)
                {
                    if (attribute != null && attribute.Name.IndexOf("xmlns:", StringComparison.InvariantCultureIgnoreCase) == 0)
                    {
                        string text = attribute.Name.Substring(6);
                        manager.AddNamespace(text, attribute.Value);
                    }
                }
            }

            return manager;
        }
    }
}
